package extensions.generic;

import org.uddi4j.*;
import org.uddi4j.client.*;
import org.uddi4j.datatype.*;
import org.uddi4j.datatype.assertion.*;
import org.uddi4j.datatype.binding.*;
import org.uddi4j.datatype.business.*;
import org.uddi4j.datatype.service.*;
import org.uddi4j.datatype.tmodel.*;
import org.uddi4j.request.*;
import org.uddi4j.response.*;
import org.uddi4j.util.*;

import java.util.*;
import java.net.*;
import java.io.*;

public class FindData {

  String accesspoint;
  String simpurl;
  String sinfurl;
  String[] bName;
  String[] sName;
  UDDIProxy proxy;

  public FindData() {}

  public Hashtable findService(String searchWord) {
    // Construct a UDDIProxy object.
    UDDIProxy proxy = new UDDIProxy();
    Hashtable finddata = new Hashtable();   

    // Select the desired UDDI server node
    String inurl = "http://winnipeg.ucs.indiana.edu/services/uddi/inquiryAPI";
    String puburl = "http://winnipeg.ucs.indiana.edu/services/uddi/publishAPI";

    try {
      
      // Select the desired UDDI server node
      proxy.setInquiryURL(inurl);
      proxy.setPublishURL(puburl);

      //creating vector of Name Object
      Vector names = new Vector();
      //names.add(new Name(bEntity));
      names.add(new Name("%"));

      // Setting FindQualifiers to 'caseSensitiveMatch'
      FindQualifiers findQualifiers = new FindQualifiers();
      Vector qualifier = new Vector();
      qualifier.add(new FindQualifier("sortByNameAsc"));
      qualifier.add(new FindQualifier("sortByDateAsc"));
      findQualifiers.setFindQualifierVector(qualifier);
         
      // Find businesses by name
      // And setting the maximum rows to be returned as 5.
      BusinessList businessList = proxy.find_business(names, null, null, null,null,findQualifiers,100);
      
      Vector businessInfoVector = null;
      try {
        businessInfoVector = businessList.getBusinessInfos().getBusinessInfoVector();
      } catch (java.lang.NullPointerException e1) {
        bName = new String[1];
        bName[0] = null;
        return finddata;
      }

      if(businessInfoVector.size() == 0) { 
        bName = new String[1];
        bName[0] = null;
	return finddata; }

      //checking words
      boolean flagword = false;
      String tmp = searchWord;

      if(tmp.equalsIgnoreCase("queue") || tmp.equalsIgnoreCase("gateway") ||
         tmp.equalsIgnoreCase("sdsc") || tmp.equalsIgnoreCase("pbs") ||
         tmp.equalsIgnoreCase("lsf") || tmp.equalsIgnoreCase("loadleveler")
         || tmp.equalsIgnoreCase("nqs") ) {
        searchWord = "batch";
        flagword = true;
      }
      
      BusinessInfo businessInfo = null;
      String bKey = null;
      bName = new String[businessInfoVector.size()];

      for (int i = 0; i < businessInfoVector.size(); i++) {
        businessInfo = (BusinessInfo)businessInfoVector.elementAt(i);
        
        // Print name for each business
        bName[i] = businessInfo.getNameString();
        bKey = businessInfo.getBusinessKey();

        System.out.println("Business Name: "+bName[i]);
        System.out.println("Business Key: "+bKey);
        String bID = bName[i]+bKey;

        //creating vector of Name Object
        names = new Vector();
        names.add(new Name(searchWord));
        
        // Setting FindQualifiers to 'caseSensitiveMatch'
        findQualifiers = new FindQualifiers();
        qualifier = new Vector();
        //qualifier.add(new FindQualifier("caseSensitiveMatch"));
        qualifier.add(new FindQualifier("sortByNameAsc"));
        qualifier.add(new FindQualifier("sortByDateAsc"));
        findQualifiers.setFindQualifierVector(qualifier);

        ServiceList sList = proxy.find_service(bKey,names,null,null,findQualifiers,100);
        Vector serviceInfoVector = null;
        boolean flag = true;

        try {
          serviceInfoVector = sList.getServiceInfos().getServiceInfoVector();
        } catch (java.lang.NullPointerException e1) {
          //sName = new String[1];
          //sName[0] = null;
          //return finddata;
	  System.out.println("Can not find service!!!");
          bName[i] = null;
          flag = false;
        }

	if(serviceInfoVector.size() == 0) {
          System.out.println("Can not find service!!!");
          bName[i] = null;
          flag = false;
	}
        
        if(flag) {
          ServiceInfo serviceInfo = null;
          Hashtable servicePair = new Hashtable();
          sName = new String[serviceInfoVector.size()];
        
          for (int j = 0; j < serviceInfoVector.size(); j++) {
            serviceInfo = (ServiceInfo)serviceInfoVector.elementAt(j);
            sName[j] = serviceInfo.getNameString();
            System.out.println("Service Name: "+serviceInfo.getNameString());
            System.out.println("Service Key: "+serviceInfo.getServiceKey()); 
            
            if(flagword) {

              ServiceDetail sDetail = proxy.get_serviceDetail(serviceInfo.getServiceKey());
              Vector bSInfoVec = sDetail.getBusinessServiceVector();
              BusinessService bService = (BusinessService)bSInfoVec.elementAt(0);
              //String dname = bService.getDefaultNameString();
              //System.out.println("DNAME: "+dname);

              String desc = bService.getDefaultDescriptionString();
              System.out.println("Description: "+desc);
              StringTokenizer st = new StringTokenizer(desc,"+");
              boolean checkKey = false;

              while(st.hasMoreTokens()) {
                String nexttk = st.nextToken();
                nexttk = nexttk.toLowerCase();
                String tmp1 = tmp.toLowerCase();
                if(nexttk.equals(tmp1) || nexttk.startsWith(tmp1)) {
                  servicePair.put(sName[j],serviceInfo.getServiceKey());
                  checkKey = true;
                  break;
                }
              }
              if(!checkKey) bName[i] = null; 
              else finddata.put(bID,servicePair);

            } else {
              servicePair.put(sName[j],serviceInfo.getServiceKey());
              finddata.put(bID,servicePair);
            }
          }

        }
      }

      // Handle possible errors
    } catch (UDDIException e) {
      DispositionReport dr = e.getDispositionReport();
      if (dr!=null) {
        System.out.println("UDDIException faultCode:" + e.getFaultCode() +
                           "\n operator:" + dr.getOperator() +
                           "\n generic:"  + dr.getGeneric() +
                           "\n errno:"    + dr.getErrno() +
                           "\n errCode:"  + dr.getErrCode() +
                           "\n errInfoText:" + dr.getErrInfoText());
      }
      e.printStackTrace();
      
      // Catch any other exception that may occur
    } catch (java.net.MalformedURLException e2) {
      System.out.println("URL problem.......");
    } catch (org.uddi4j.transport.TransportException e3) {
      System.out.println("UDDI Transport problem........");
    }
    return finddata;

  }
  
  public Hashtable findBusiness(String searchWord) {
    // Construct a UDDIProxy object.
    UDDIProxy proxy = new UDDIProxy();
    Hashtable finddata = new Hashtable();   

    // Select the desired UDDI server node
    String inurl = "http://winnipeg.ucs.indiana.edu/services/uddi/inquiryAPI";
    String puburl = "http://winnipeg.ucs.indiana.edu/services/uddi/publishAPI";

    try {
      
      // Select the desired UDDI server node
      proxy.setInquiryURL(inurl);
      proxy.setPublishURL(puburl);

      //creating vector of Name Object
      Vector names = new Vector();
      names.add(new Name(searchWord));

      // Setting FindQualifiers to 'caseSensitiveMatch'
      FindQualifiers findQualifiers = new FindQualifiers();
      Vector qualifier = new Vector();
      //qualifier.add(new FindQualifier("caseSensitiveMatch"));
      qualifier.add(new FindQualifier("sortByNameAsc"));
      qualifier.add(new FindQualifier("sortByDateAsc"));
      findQualifiers.setFindQualifierVector(qualifier);
         
      // Find businesses by name
      // And setting the maximum rows to be returned as 5.
      BusinessList businessList = proxy.find_business(names, null, null, null,null,findQualifiers,100);
      
      Vector businessInfoVector = null;
      try {
        businessInfoVector = businessList.getBusinessInfos().getBusinessInfoVector();
      } catch (java.lang.NullPointerException e1) {
	System.out.println("Can not find business!!!");
        bName = new String[1];
        bName[0] = null;
        return finddata;
      }

       if(businessInfoVector.size() == 0) {
        bName = new String[1];
        bName[0] = null;
        return finddata; }

      BusinessInfo businessInfo = null;
      String bKey = null;
      bName = new String[businessInfoVector.size()];

      for (int i = 0; i < businessInfoVector.size(); i++) {
        businessInfo = (BusinessInfo)businessInfoVector.elementAt(i);
        
        // Print name for each business
        bName[i] = businessInfo.getNameString();
        bKey = businessInfo.getBusinessKey();

        System.out.println("Business Name: "+bName[i]);
        System.out.println("Business Key: "+bKey);
        String bID = bName[i]+bKey;

        Vector serviceInfoVector = null;
        boolean flag = true;

        try {
          serviceInfoVector = businessInfo.getServiceInfos().getServiceInfoVector();
        } catch (java.lang.NullPointerException e1) {
          //sName = new String[1];
          //sName[0] = null;
          //return finddata;
          bName[i] = null;
          flag = false;
        }

        if(serviceInfoVector.size() == 0) {
          System.out.println("Can not find service!!!");
          bName[i] = null;
          flag = false;
        }
        
        if(flag) {
          ServiceInfo serviceInfo = null;
          Hashtable servicePair = new Hashtable();
          sName = new String[serviceInfoVector.size()];
        
          for (int j = 0; j < serviceInfoVector.size(); j++) {
            serviceInfo = (ServiceInfo)serviceInfoVector.elementAt(j);
            sName[j] = serviceInfo.getNameString();
            System.out.println("Service Name: "+serviceInfo.getNameString());
            System.out.println("Service Key: "+serviceInfo.getServiceKey()); 
            servicePair.put(sName[j],serviceInfo.getServiceKey());
          }

          finddata.put(bID,servicePair);
        }
      }

      // Handle possible errors
    } catch (UDDIException e) {
      DispositionReport dr = e.getDispositionReport();
      if (dr!=null) {
        System.out.println("UDDIException faultCode:" + e.getFaultCode() +
                           "\n operator:" + dr.getOperator() +
                           "\n generic:"  + dr.getGeneric() +
                           "\n errno:"    + dr.getErrno() +
                           "\n errCode:"  + dr.getErrCode() +
                           "\n errInfoText:" + dr.getErrInfoText());
      }
      e.printStackTrace();
      
      // Catch any other exception that may occur
    } catch (java.net.MalformedURLException e2) {
      System.out.println("URL problem.......");
    } catch (org.uddi4j.transport.TransportException e3) {
      System.out.println("UDDI Transport problem........");
    }
    return finddata;

  }
  
  private String getWSDLFromURL(String url, String WSDLFile)
  {
    System.out.println("Getting WSDL from url:"+url);
    String wsdlform = "";
    String thisLine=null;
    //Open the URL for reading
    try {
      URL u = new URL(url);
      // now turn the URL into a DataInputStream
      try {
        BufferedReader theHTML = new BufferedReader(new InputStreamReader(u.openStream()));
        FileOutputStream file = new FileOutputStream(WSDLFile);
        PrintWriter out = new PrintWriter(file);

        while ((thisLine = theHTML.readLine()) != null) {
          //System.out.println("configReader:getIORfromURL:line"+thisLine);
          wsdlform += thisLine;
          out.println(thisLine);
        } // while loop ends here
        out.flush();
        file.close();
      } // end try
      catch (Exception e) {
        System.out.println("Find Service:getIORfromURL:"+e);
      }
      
    } // end try
    catch (MalformedURLException e) {
      System.out.println("Find Service:getIORfromURL:"+url + " is not a parseable URL");
      System.out.println("Find Service:getIORfromURL:"+e);
    }

    return wsdlform;
    
  }

  public String getAccessPoint(String serviceKey) {

    // Construct a UDDIProxy object.
    UDDIProxy proxy = new UDDIProxy();

    // Select the desired UDDI server node
    String inurl = "http://winnipeg.ucs.indiana.edu/services/uddi/inquiryAPI";
    String puburl = "http://winnipeg.ucs.indiana.edu/services/uddi/publishAPI";

    try {
      // Select the desired UDDI server node
      proxy.setInquiryURL(inurl);
      proxy.setPublishURL(puburl);
      
      ServiceDetail serviceDetail = proxy.get_serviceDetail(serviceKey);
      Vector businessServiceInfoVector = serviceDetail.getBusinessServiceVector();
      BusinessService businessService = (BusinessService)businessServiceInfoVector.elementAt(0);
      Vector bindingTemplateInfoVector = businessService.getBindingTemplates().getBindingTemplateVector();
      
      BindingTemplate bindingTemplate = null;
      for (int k = 0; k < bindingTemplateInfoVector.size(); k++) {
        bindingTemplate = (BindingTemplate)bindingTemplateInfoVector.elementAt(k);
      }
      AccessPoint acessPoint = bindingTemplate.getAccessPoint();
      accesspoint = acessPoint.getText();
      //System.out.println("AccessPoint(Biding): "+acessPoint.getText());

      /*
      Vector tmodelInfoVector = bindingTemplate.getTModelInstanceDetails().getTModelInstanceInfoVector();

      TModelInstanceInfo tmodelInstanceInfo = null;
      for (int l = 0; l < tmodelInfoVector.size(); l++) {
        tmodelInstanceInfo = (TModelInstanceInfo)tmodelInfoVector.elementAt(l);
        InstanceDetails instanceDetails = tmodelInstanceInfo.getInstanceDetails();
      
        //InstanceParms instanceParms = instanceDetails.getInstanceParms();
        OverviewDoc simpURL = instanceDetails.getOverviewDoc();
        simpurl = simpURL.getOverviewURLString();
        
        //System.out.println(instanceParms.getText());
        System.out.println("WSDL Service Imp: "+simpURL.getOverviewURLString());
        TModelDetail tmodelDetail = proxy.get_tModelDetail(tmodelInstanceInfo.getTModelKey());
        Vector tmodelVector = tmodelDetail.getTModelVector();
        //TModel tmodel =null;
        for(int m=0; m<tmodelVector.size();m++) {
          TModel tmodel = (TModel)tmodelVector.elementAt(m);
          OverviewDoc sinfURL = tmodel.getOverviewDoc();
          sinfurl = sinfURL.getOverviewURLString();
          System.out.println("WSDL Service Inf: "+sinfURL.getOverviewURLString());
        }
      }
      */
    
      // Handle possible errors
    } catch (UDDIException e) {
      DispositionReport dr = e.getDispositionReport();
      if (dr!=null) {
        System.out.println("UDDIException faultCode:" + e.getFaultCode() +
                           "\n operator:" + dr.getOperator() +
                           "\n generic:"  + dr.getGeneric() +
                           "\n errno:"    + dr.getErrno() +
                           "\n errCode:"  + dr.getErrCode() +
                           "\n errInfoText:" + dr.getErrInfoText());
      }
      e.printStackTrace();
    } catch (org.uddi4j.transport.TransportException e3) {
      System.out.println("UDDI Transport problem........");
    } catch (java.net.MalformedURLException e2) {
      System.out.println("URL problem.......");
    }
    return accesspoint;

  }

  public String getServiceName(String serviceKey) {

    // Construct a UDDIProxy object.
    UDDIProxy proxy = new UDDIProxy();

    // Select the desired UDDI server node
    String inurl = "http://winnipeg.ucs.indiana.edu/services/uddi/inquiryAPI";
    String puburl = "http://winnipeg.ucs.indiana.edu/services/uddi/publishAPI";

    String srvName = null;
    try {
      // Select the desired UDDI server node
      proxy.setInquiryURL(inurl);
      proxy.setPublishURL(puburl);
      
      ServiceDetail serviceDetail = proxy.get_serviceDetail(serviceKey);
      Vector businessServiceInfoVector = serviceDetail.getBusinessServiceVector();
      BusinessService businessService = (BusinessService)businessServiceInfoVector.elementAt(0);
      srvName = businessService.getDefaultNameString();

      // Handle possible errors
    } catch (UDDIException e) {
      DispositionReport dr = e.getDispositionReport();
      if (dr!=null) {
        System.out.println("UDDIException faultCode:" + e.getFaultCode() +
                           "\n operator:" + dr.getOperator() +
                           "\n generic:"  + dr.getGeneric() +
                           "\n errno:"    + dr.getErrno() +
                           "\n errCode:"  + dr.getErrCode() +
                           "\n errInfoText:" + dr.getErrInfoText());
      }
      e.printStackTrace();
    } catch (org.uddi4j.transport.TransportException e3) {
      System.out.println("UDDI Transport problem........");
    } catch (java.net.MalformedURLException e2) {
      System.out.println("URL problem.......");
    }
    return srvName;
  }



  /*
  public String getAccessPoint() {
    return accesspoint;
  }
  
  public String getSimpURL() {
    return simpurl;
  }
  
  public String getSinfURL() {
    return sinfurl;
  }
  */

  /*
  public void setBusinessName(String name) {
    businessName = name;
  }
  */

  public String[] getBusinessNames() {
    return bName;
  }

  /*
  public String[] getServiceNames() {
    return sName;
  }
  */

}

